/* Placed in public domain by Dmitry Mityugov, 2003 */

#include <nwcalls.h>
#include <nwclxcon.h>
#include <nwsm.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main( int argc, char* argv[]) {
	char const* server_name;
	char const* user_name;
	char const* password;
	char const* ncf_name;
	NWRCODE rcode;
	NWCCODE ccode;
	NWCONN_HANDLE conn_handle;
	if ( argc != 5) {
		puts( "\rUsage: RNCF <servername> <username> <password> <ncf_name>");
		return EXIT_FAILURE;
	}
	ccode = NWCallsInit( NULL, NULL);
	if ( ccode != 0) {
		printf( "\rRNCF: NWCallsInit failed, ccode = %x\n", ccode);
		return EXIT_FAILURE;
	}
	server_name = strupr( argv[ 1]);
	user_name = strupr( argv[ 2]);
	password = strupr( argv[ 3]);
	ncf_name = strupr( argv[ 4]);
	rcode = NWCCOpenConnByName( 0,
		server_name,
		NWCC_NAME_FORMAT_BIND,
		NWCC_OPEN_LICENSED,
		NWCC_TRAN_TYPE_WILD,
		&conn_handle);
	if ( rcode != 0) {
		printf( "\rRNCF: NWCCOpenConnByName failed, rcode = %x\n", rcode);
		NWCallsTerm( NULL);
		return EXIT_FAILURE;
	}
	ccode = NWLoginToFileServer( conn_handle, user_name, OT_USER, password);
	if ( ccode != 0) {
		printf( "\rRNCF: NWLoginToFileServer failed, ccode = %x\n", ccode);
		NWCCCloseConn( conn_handle);
		NWCallsTerm( NULL);
		return EXIT_FAILURE;
	}
	ccode = NWSMExecuteNCFFile( conn_handle, ncf_name);
	if ( ccode != 0) {
		printf( "\rRNCF: NWSMExecuteNCFFile failed, ccode = %x\n", ccode);
		NWCCCloseConn( conn_handle);
		NWCallsTerm( NULL);
		return EXIT_FAILURE;
	}
	NWCCCloseConn( conn_handle);
	NWCallsTerm( NULL);
	return EXIT_SUCCESS;
}
